=== debian/changelog ===
ros-eloquent-uncrustify-vendor (1.3.0-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Steven! Ragnarök <steven@openrobotics.org>  Tue, 17 Sep 2019 17:50:53 -0000
